<template>
  <div
    class="i-button"
    :class="{
      'i-button--block': block,
      'i-button--small': small,
      'i-button--transparent': transparent,
      'i-button--white': white,
      'i-button--loading': loading,
      'i-button--bordered': bordered,
    }">
    <nuxt-link
      v-if="to"
      tag="button"
      :type="type"
      class="i-button__button"
      :to="to"
      @click="onClick"
      :disabled="disabled">
      <span class="i-button__content">
        <slot />
      </span>
    </nuxt-link>
    <button v-else :type="type" class="i-button__button" @click="onClick" :disabled="disabled">
      <img v-if="doUseBlackSpinner" src="~assets/images/spinner-black.svg" class="i-button__spinner" />
      <img v-else src="~assets/images/spinner-white.svg" class="i-button__spinner" />
      <span class="i-button__content">
        <img v-if="icon" :src="icon" class="i-button__icon" />
        <slot />
      </span>
    </button>
    <div class="i-button__shadow"></div>
  </div>
</template>

<script>
  export default {
    props: {
      to: {
        type: String,
      },

      submit: {
        type: Boolean,
        default: false,
      },

      disabled: {
        type: Boolean,
        default: false,
      },

      loading: {
        type: Boolean,
        default: false,
      },

      transparent: {
        type: Boolean,
        default: false,
      },

      block: Boolean,
      small: Boolean,
      white: Boolean,
      icon: String,
      bordered: Boolean,
      paymentRequestButtonId: String,
    },

    computed: {
      type() {
        return this.submit ? 'submit' : 'button';
      },

      doUseBlackSpinner() {
        return this.transparent || this.white;
      },
    },

    methods: {
      onClick() {
        this.$emit('click');
      },
    },
  };
</script>

<style lang="scss">
  .i-button {
    position: relative;
    display: inline-flex;
    align-items: center;
    justify-content: center;
    min-width: rs(58px);
    height: rs(58px);
  }

  .i-button.i-button--block {
    width: 100%;
  }

  .i-button.i-button--small {
    min-width: rs(41px);
    height: rs(41px);
  }

  .i-button__button {
    position: relative;
    display: inline-block;
    box-sizing: border-box;
    z-index: 1;
    width: 100%;
    height: 100%;
    border: 0;
    background: linear-gradient(90deg, #fc866f 0%, #fea263 93.31%);
    border-radius: rs(math.div(58px, 2));
    font-weight: bold;
    font-size: rf(16px);
    color: #fff;
    cursor: pointer;
    padding: 0 rs(10px);

    &:disabled {
      opacity: 0.7;
      cursor: default;
    }
  }

  .i-button.i-button--bordered .i-button__button {
    border: rs(2px) solid #575167;
  }

  .i-button.i-button--small .i-button__button {
    font-size: rf(14px);
    border-radius: rs(math.div(41px, 2));
  }

  .i-button.i-button--transparent .i-button__button {
    background: transparent;
    color: #575167;
  }

  .i-button.i-button--white .i-button__button {
    background: #fff;
    color: #575167;
  }

  .i-button__icon {
    width: rs(25px);
  }

  .i-button__icon:not(:last-child) {
    margin-right: rs(5px);
  }

  .i-button__spinner {
    position: absolute;
    z-index: 1;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    width: rs(35px);
    height: rs(35px);
    pointer-events: none;
    opacity: 1;
    transition: opacity 0.1s;
  }

  .i-button:not(.i-button--loading) .i-button__spinner {
    opacity: 0;
  }

  .i-button__content {
    display: flex;
    justify-content: center;
    align-items: center;
    opacity: 1;
    transition: opacity 0.1s;
  }

  .i-button--loading .i-button__content {
    opacity: 0;
  }

  .i-button__shadow {
    position: absolute;
    z-index: 0;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 5px);
    width: 85%;
    height: 45%;
    background: linear-gradient(90deg, #fc856e 0%, #fea263 100%);
    filter: blur(30px);
    border-radius: 20px;
  }

  .i-button--transparent .i-button__shadow {
    display: none;
  }

  .i-button--white .i-button__shadow {
    background: linear-gradient(90deg, #afafaf 0%, #888 100%);
  }
</style>
